#include <cstdio>
#include <cstdlib>
#include <cstring>
#include <cmath>

const int MAXN = 1001;

#define min(a,b) ((a)<=(b)?(a):(b))
#define sgn(a) ((a)<0?-1:1)

int pnts[MAXN][3];

int pnt_dists[MAXN][3]; // distance to each point


int pnt_compare(const void *a, const void *b)
{
	int x1 = *(int*)a;
	int y1 = *((int*)a+1);
	int z1 = *((int*)a+2);

	int x2 = *(int*)b;
	int y2 = *((int*)b+1);
	int z2 = *((int*)b+2);

	if(x1<0)
	{
		x1=-x1;
		y1=-y1;
		z1=-z1;
	}
	if(x2<0)
	{
		x2=-x2;
		y2=-y2;
		z2=-z2;
	}

	if(x1==0 && x2>0)
		return -1;
	else if(x1>0 && x2==0)
		return 1;
	else if(x1==0 && x2==0)
	{
		if(y1<0)
		{
			y1=-y1;
			z1=-z1;
		}
		if(y2<0)
		{
			y2=-y2;
			z2=-z2;
		}

		if(y1==0 && y2>0)
			return -1;
		else if(y1>0 && y2==0)
			return 1;
		else if(y1==0 && y2==0)
			return 0;
		else
		{
			if(z1*y2<z2*y1)
				return -1;
			else if(z1*y2>z2*y1)
				return 1;
			else
				return 0;
		}
	}
	else
	{
		if(y1*x2<y2*x1)
			return -1;
		else if(y1*x2>y2*x1)
			return 1;
		else if(z1*x2<z2*x1)
			return -1;
		else if(z1*x2>z2*x1)
			return 1;
		else
			return 0;
	}
}


int main()
{
	int i,j,k;
	int n;
	int total=0;

	freopen("points.in","rt",stdin);
	scanf("%d",&n);
	for(i=0;i<n;i++)
		scanf("%d%d%d",&pnts[i][0],&pnts[i][1],&pnts[i][2]);
	fclose(stdin);


	for(i=0;i<n;i++)
	{
		for(j=0,k=0;j<n;j++)
			if(j!=i) 
			{
				pnt_dists[k][0]=pnts[j][0]-pnts[i][0];
				pnt_dists[k][1]=pnts[j][1]-pnts[i][1];
				pnt_dists[k][2]=pnts[j][2]-pnts[i][2];
				k++;
			}

		qsort(pnt_dists,n-1,sizeof(pnt_dists[0]),pnt_compare);

		int first=0;
		int minx=pnt_dists[0][0];
		int miny=pnt_dists[0][1];
		int minz=pnt_dists[0][2];
		
		for(j=0;j<n;j++)
			if(j==n-1 || pnt_compare(pnt_dists[j-1],pnt_dists[j])!=0)
			{
				if(j-first>=2)
					if((minx>0 || minx==0 && miny>0 || minx==0 && miny==0 && minz>0))
				{
					total++;
				}
				if(j==n-1) break;
				first=j;
				minx=pnt_dists[j][0];
				miny=pnt_dists[j][1];
				minz=pnt_dists[j][2];
			}
			else
			{
				minx=min(minx,pnt_dists[j][0]);
				miny=min(miny,pnt_dists[j][1]);
				minz=min(minz,pnt_dists[j][2]);
			}
	}


	freopen("points.out","wt",stdout);
	printf("%d\n",total);
	fclose(stdout);

	return 0;
}

