{$R-,Q-}
{$APPTYPE CONSOLE}
program bunku;

type hashType = longint;
type elemType = char;

const MAXX = 2000 + 2;
const MAXY = 2000 + 2;
const MAXSZ = 2000 + 2;//the maximum out of maxx and maxy

type tHash = array[1..MAXY, 1..MAXX]of hashType;
type tPicture = array[1..MAXY, 1..MAXX] of elemType;
type tHashLine = array[1..MAXSZ]of hashType;
var f:text;
map: tPicture;
h: tHash;
mapX, mapY: longint;
objX, objY, objOX, objOY: longint;

s: array[1..MAXX * MAXY + 10] of hashType;

procedure readPicture(var xsz,ysz:longint; var res:tPicture);
var i,j:longint;
ss:ansistring;
begin
  readln(f,ysz,xsz);
  for j:= 1 to ysz do
   begin
     readln(f,ss);
     for i:=1 to xsz do
       res[j, i]:=ss[i];
   end;
end;

const hashMod1 = 973741837;
const hashBase1 = 2;

const hashMod2 = 615827881;
const hashBase2 = 3;

function positiveMod(a,b:hashType):hashType;
begin
  positiveMod:=((a mod b) + b) mod b;
end;

procedure calcHashLine(var src, dest:tHashLine; sz, delta:longint;hashMod, hashBase, hashDelta:hashType);
var i,dt:longint;
oldHash:hashType;
bigHashDelta: int64;
begin
  bigHashDelta:=int64(hashDelta);
  oldHash:=0;
  for i:=1 to delta do
   begin
     oldHash:=((oldHash * hashBase) mod hashMod + src[i]) mod hashMod;
     dest[i]:=oldHash;
   end;
  for i:=delta + 1 to sz do
   begin
     dt:=(bigHashDelta * src[i - delta]) mod hashMod;
     oldHash:=(((positiveMod(oldHash - dt, hashMod)) * hashBase) mod hashMod + src[i]) mod hashMod;
     dest[i]:=oldHash;
   end;
end;

function put(a:hashType; b:longint; md:hashType):hashType;
var res:hashType;
i:longint;
begin
  res:=1;
  for i:=1 to b do
   res:=(res * a) mod md;
  put:=res;
end;

function max(a,b:longint):longint;
begin
  if a>b then max:=a
   else max:=b;
end;

var src, dest:tHashLine;

procedure calcHash(var obj:tPicture;xs,ys,xh,yh:longint;var h:tHash);
var xc,yc:longint;
    hashDelta: hashType;
    //line: pArrayOfElem;
begin
  //round1: x-level hash
  hashDelta:=put(hashBase1, xh - 1, hashMod1);
  for yc:=1 to ys do
   begin
     for xc:=1 to xs do {copy source object and convert to hashtype}
       src[xc]:=ord(obj[yc,xc]);
     calcHashLine(src, dest, xs, xh, hashMod1, hashBase1, hashDelta);
     for xc:=1 to xs do
       h[yc,xc]:=dest[xc];
   end;

   //round2: y-level hash
   hashDelta:=put(hashBase2, yh - 1, hashMod2);
   for xc:=1 to xs do
    begin
      for yc:=1 to ys do
        src[yc]:=h[yc,xc];
      calcHashLine(src, dest, ys, yh, hashMod2, hashBase2, hashDelta);
      for yc:=1 to ys do
        h[yc,xc]:=dest[yc];
    end;
end;

function align(k:hashType; len:longint):string;
var r:string;
begin
  str(k, r);
  while (length(r) < len) do
    r:=' ' + r;
  align:=r;
end;

procedure writeHash(var f:text; var h:tHash;x,y:longint);
var i, j:longint;
begin
  writeln(f, 'new hash:');
  for i:=1 to y do
    begin
      for j:=1 to x do
        write(f,align(h[i,j], 13), ' ');
      writeln(f);
    end;
end;

procedure qsort(l, r: longint);
var i,j: longint;
p, aux: hashType;
begin
  i:= l;
  j:= r;
  p:=s[(l + r) div 2];
  repeat
    while (s[i] < p) do inc(i);
    while (s[j] > p) do dec(j);
    if (i <= j) then
     begin
       aux:= s[i];
       s[i]:= s[j];
       s[j]:= aux;
       inc(i);
       dec(j);
     end;
  until i>j;
  if (j > l) then qsort(l, j);
  if (i < r) then qsort(i, r);
end;

procedure sort(used:longint);
begin
  qsort(1, used);
end;

procedure fmf(used: longint; var mf: hashType);{find the most frequent hashcode in s} 
var start, i: longint;
maxItem: hashType;
maxNr: longint;
begin
  start:= 1;
  maxNr:= -1;
  maxItem:= -1;
  s[used+1]:= s[used] + 1;
  for i:= 2 to used+1 do
   if (s[i] <> s[start]) then
    begin
      if (i - start) > maxNr then
       begin
         maxNr:= i - start;
         maxItem:= s[start];
       end;
      start:=i;
    end;
   mf:=maxItem;
end;

procedure decodeCoos(c:longint; var x, y:longint);
begin
  x:= c mod MAXX + 1;
  y:= c div MAXX;
end;

function encodeCoos(x, y: longint):longint;
begin
  encodeCoos:= x - 1 + y * MAXX;
end;

function match(adr1, adr2: longint; objX, objY: longint): boolean;
var x1, y1, x2, y2: longint;
i, j:longint;
begin
  decodeCoos(adr1, x1, y1);
  decodeCoos(adr2, x2, y2);

  match:= false;
  for i:=0 to objY - 1 do
   for j:=0 to objX - 1 do
    if (map[i + y1, j + x1] <> map[i + y2, j + x2]) then exit;

  match:= true;
end;

var i,j,k,used, objOrigin:longint;
mf: hashType;
begin
  assign(f,'cipher.in');
  reset(f);
  readPicture(mapX, mapY, map);
  readln(f, objY, objX);
  close(f);
  calcHash(map, mapX, mapY, objX, objY, h);
  {assign(f,'cricova_debug.out');
  rewrite(f);
  writeHash(f, h, mapX, mapY);
  close(f);}
  used:=0;
  for i:=objY to mapY do
   for j:=objX to mapX do
    begin
      inc(used);
      s[used]:=h[i, j];
    end;
  sort(used);
  fmf(used, mf);
  used:= 0;
  //write into S the list of matching hashes
  for i:= objY to mapY do
   for j:=objX to mapX do
    if h[i,j] = mf then
     begin
       inc(used);
       s[used]:= encodeCoos(j - objX + 1, i - objY + 1);
     end;

  if (match(s[1], s[2], objX, objY)) then objOrigin:= s[1]
    else objOrigin:= s[3];
  assign(f, 'cipher.out');
  rewrite(f);
  decodeCoos(objOrigin, objOX, objOY);
  writeln(f, objY, ' ', objX);
  for i:= objOY to objOY + objY - 1 do
   begin
     for j:= objOX to objOX + objX - 1 do
      write(f, map[i, j]);
     writeln(f);
   end;
  writeln(f, used);
  for i:= 1 to used do
   begin
     decodeCoos(s[i], j, k);
     writeln(f, k, ' ', j);
   end; 
  close(f);
  writeln(mf);
end.

 
